<?php
/*
    [123imagestock] (C)2006-2007 123imagestock Software. All Rights Reserved.
    This is NOT a freeware, use is subject to license terms
*/
define('ROOT_PATH', './');
define('PHP_PATH', 'php/');
if (file_exists(ROOT_PATH."config.php")) {
  require_once(ROOT_PATH.'config.php');
}
if (defined("IMS_ACTIVE")) {
  header("Location: ".ROOT_PATH.PHP_PATH."image.php");
  exit;
}
require_once(ROOT_PATH."includes/functions.php");
if (isset($_REQUEST['action'])) {
  $action = $_REQUEST['action'];
}
else {
  $action = "";
}
if ($action == "") {
  $action = "intro";
}
$lang_select = "";
$folderlist = array();
$handle = opendir(ROOT_PATH."lang");
while ($folder = readdir($handle)) {
  if (is_dir(ROOT_PATH."lang/$folder") && $folder != "." && $folder != "..") {
    $folderlist[] = $folder;
  }
}
sort($folderlist);
for($i = 0; $i < sizeof($folderlist); $i++) {
  $lang_select .= " <b><a href=\"install.php?install_lang=".$folderlist[$i]."\">".$folderlist[$i]."</a></b> \n";
}
closedir($handle);
if (isset($_REQUEST['install_lang'])) {
  $install_lang = ($_REQUEST['install_lang']);
}
if (empty($install_lang) || !in_array($install_lang, $folderlist)) {
  if(sizeof($folderlist)==1)
  {
     $install_lang=$folderlist[0]; 
  }
  else
  {
      $install_lang = "english";
  }
}
include(ROOT_PATH.'lang/'.$install_lang.'/install.php');
$db_servertype   = (isset($_REQUEST['db_servertype'])) ? trim($_REQUEST['db_servertype']) : "mysql";
$db_host         = (isset($_REQUEST['db_host'])) ? trim($_REQUEST['db_host']) : "";
$db_name         = (isset($_REQUEST['db_name'])) ? trim($_REQUEST['db_name']) : "";
$db_user         = (isset($_REQUEST['db_user'])) ? trim($_REQUEST['db_user']) : "";
$db_password     = (isset($_REQUEST['db_password'])) ? trim($_REQUEST['db_password']) : "";
$table_prefix    = (isset($_REQUEST['table_prefix'])) ? trim($_REQUEST['table_prefix']) : "ims_";
$admin_user      = (isset($_REQUEST['admin_user'])) ? trim($_REQUEST['admin_user']) : "";
$admin_password  = (isset($_REQUEST['admin_password'])) ? trim($_REQUEST['admin_password']) : "";
$admin_password2 = (isset($_REQUEST['admin_password2'])) ? trim($_REQUEST['admin_password2']) : "";
$admin_email     = (isset($_REQUEST['admin_email'])) ? trim($_REQUEST['admin_email']) : "";
$admin_mediadir  = (isset($_REQUEST['admin_mediadir'])) ? trim($_REQUEST['admin_mediadir']) : "data";
if ($action == "downloadconfig") {
  header("Content-Type: text/x-delimtext; name=\"config.php\"");
  header("Content-disposition: attachment; filename=config.php");
  $config_file = stripslashes(trim($_REQUEST['config_file']));
  echo $config_file;
  exit;
}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
  <meta content="text/html; charset=<?php echo($lang['encoding']); ?>" http-equiv="Content-Type">
  <LINK 
href="css/imagestock1.css" 
type=text/css rel=stylesheet><LINK 
href="css/imagestock2.css" 
type=text/css rel=stylesheet>
  <title><?php echo($lang['title']); ?></title>
</head>
<body leftmargin="20" topmargin="20" marginwidth="20" marginheight="20" bgcolor="#FFFFFF">
<form action="install.php" name="form" method="post">
  <table cellpadding="0" cellspacing="0" border="0" width="500" align="center">
    <tr>
      <td align=left><img src="css/logo.png" border=0></td>
      <TD align=right>
      <DIV class=header-text><?php echo($lang['header_headline']); ?></DIV></TD></tr>
    <tr>
      <td colspan=2>
      <br/>
<?php
if ($action == "startinstall") {
  $error = array();
  if ($db_servertype == "") {
    $error['db_servertype'] = 1;
  }
  if ($db_host == "") {
    $error['db_host'] = 1;
  }
  if ($db_name == "") {
    $error['db_name'] = 1;
  }
  if ($db_user == "") {
    $error['db_user'] = 1;
  }
  /*
  if ($db_password == "")[
    $error['db_password'] = 1;
  }
  */
  if ($table_prefix == "") {
    $error['table_prefix'] = 1;
  }
  if ($admin_user == "") {
    $error['admin_user'] = 1;
  }
  if ($admin_password != $admin_password2 || $admin_password == "" || $admin_password2 == "") {
    $error['admin_password'] = 1;
    $error['admin_password2'] = 1;
  }
  if ($admin_email == "") {
    $error['admin_email'] = 1;
  }
  if (!empty($error)) {
    foreach ($error as $key => $val) {
      $lang[$key] = sprintf("<span>%s *</span>", $lang[$key]);
    }
    $action = "intro";
  }
  else {
?>
        <table cellpadding="3" cellspacing="1" border="0" width="100%">
          <tr>
            <td>
<?php
    $error_log = array();
    $error_msg = "";
    include(ROOT_PATH.'includes/db_mysql.php');
    $site_db = new Db($db_host, $db_user, $db_password, $db_name);
    if (!$site_db->connection) {
      $error_log[] = "No connection to database!";
    }
    include(ROOT_PATH.'includes/db_utils.php');
    $db_file = ROOT_PATH."mysql_default.sql";
    $cont = fread(fopen($db_file, 'r'), filesize($db_file));
    if (empty($cont)) {
      $error_log[] = "Could not load: ".$db_file;
    }
    if (empty($error_log)) {
      $cont = preg_replace('/ims_/', $table_prefix, $cont);
      $pieces = split_sql_dump($cont);
      for ($i = 0; $i < sizeof($pieces); $i++) {
        $sql = trim($pieces[$i]);
        if (!empty($sql) and $sql[0] != "#") {
          if (!$site_db->query($sql)) {
            $error_log[] = $sql;
          }
        }
      }
      $admin_pass_md5 = md5($admin_password);
      $current_time = time();
      $sql = "insert into ".$table_prefix."users

(user_name,user_password,user_email,user_joindate,user_lastvisit,user_comments,user_role) values 

('$admin_user','$admin_pass_md5','$admin_email',$current_time,$current_time,'',2)";
      if (!$site_db->query($sql)) {
        $error_log[] = $sql;
      }
    }
    if (empty($error_log)) {
      $config_file = '<?php'."\n";
      $config_file .= '$db_servertype = "'.$db_servertype.'";'."\n";
      $config_file .= '$db_host = "'.$db_host.'";'."\n";
      $config_file .= '$db_name = "'.$db_name.'";'."\n";
      $config_file .= '$db_user = "'.$db_user.'";'."\n";
      $config_file .= '$db_password = "'.$db_password.'";'."\n\n";
      $config_file .= '$table_prefix = "'.$table_prefix . '";'."\n\n";
      $config_file .= '$language = "'.$install_lang . '";'."\n\n";
      $config_file .= '$media_dir = "'.$admin_mediadir . '";'."\n\n";
      $config_file .= 'define("IMS_ACTIVE", 1);'."\n\n";
      $config_file .= '?>';
      umask(0111);
      $fp = fopen('./config.php', 'w');
      $ok = fwrite($fp, $config_file);
      if (!$ok) {
        $cant_write_config = 1;
      }
      fclose($fp);
      if(!file_exists($admin_mediadir) and mkdir($admin_mediadir, 0777)){
        $msg = "<br /><blockquote><b>".$lang['install_success']."</b>";
      }
      if (!isset($cant_write_config)) {
        $msg .= "<br /><br />".$lang['install_success_login'];
      }
      else {
        $msg .= "<br /><br />".$lang['config_download_desc'];
        $msg .= '<input type="hidden" name="config_file" value=\''.$config_file.'\' />';
        $msg .= '<input type="hidden" name="action" value="downloadconfig" />';
      }
      $msg .= "</blockquote>";
    }
    else {
      $msg = $lang['database_error'];
      $error_msg .= "<ol>";
      foreach ($error_log as $val) {
        $error_msg .= sprintf("<li>%s</li>", $val);
      }
      $error_msg .= "</ol>";
    }
?>
              <p><?php echo $msg.$error_msg ?></p>
            </td>
          </tr>
<?php
    if (isset($cant_write_config)) {
?>
          <tr>
            <td align="center"><input type="submit" value="    <?php echo $lang['config_download'] ?>    " 

name="submit"></td>
          </tr>
<?php
    }
?>
        </table>
<?php
  }
}
if ($action == "intro") {
  $db_servertype_select = "<select name=\"db_servertype\">";
  $db_types = array("mysql");         
  foreach ($db_types as $db_type) {
    $db_servertype_select .= "<option value=\"".$db_type."\"".(($db_servertype == $db_type) ? " selected=\"selected\"" : 

"").">".$db_type."</option>";
  }
    $db_servertype_select .= "</select>";
  if (!empty($error)) {
    $lang['start_install_desc'] = $lang['start_install_desc'].sprintf("<br /><br /><span>%s *</span>", $lang

['lostfield_error']);
  }
?>
        <?php echo $lang['start_install_desc'] ?>
        <table cellpadding="3" cellspacing="1" border="0" width="100%">
          <tr>
            <td colspan="2" align="right"><?php echo $lang_select; ?></td>
          </tr>
          <tr>
            <td colspan="2"><b><span><?php echo $lang['db'] ?></span></b></td>
          </tr>
          <tr>
            <td>
              <p><?php echo $lang['db_servertype'] ?></p>
            </td>
            <td>
              <p><?php echo $db_servertype_select; ?></p>
            </td>
          </tr>
          <tr>
            <td>
              <p><?php echo $lang['db_host'] ?></p>
            </td>
            <td>
              <p>
                <input type="text" size="45" name="db_host" value="<?php echo stripslashes($db_host); ?>">
              </p>
            </td>
          </tr>
          <tr>
            <td>
              <p><?php echo $lang['db_name'] ?></p>
            </td>
            <td>
              <p>
                <input type="text" size="45" name="db_name" value="<?php echo stripslashes($db_name); ?>">
              </p>
            </td>
          </tr>
          <tr>
            <td>
              <p><?php echo $lang['db_user'] ?></p>
            </td>
            <td>
              <p>
                <input type="text" size="45" name="db_user" value="<?php echo stripslashes($db_user); ?>">
              </p>
            </td>
          </tr>
          <tr>
            <td>
              <p><?php echo $lang['db_password'] ?></p>
            </td>
            <td>
              <p>
                <input type="text" size="45" name="db_password" value="<?php echo stripslashes($db_password); ?>">
              </p>
            </td>
          </tr>
          <tr>
            <td>
              <p><?php echo $lang['table_prefix'] ?></p>
            </td>
            <td>
              <p>
                <input type="text" size="45" name="table_prefix" value="<?php echo stripslashes($table_prefix); ?>">
              </p>
            </td>
          </tr>
          <tr>
            <td colspan="2"><b><span><?php echo $lang['admin'] ?></span></b></td>
          </tr>
          <tr>
            <td>
              <p><?php echo $lang['admin_user'] ?></p>
            </td>
            <td>
              <p>
                <input type="text" size="45" name="admin_user" value="<?php echo stripslashes($admin_user); ?>">
              </p>
            </td>
          </tr>
          <tr>
            <td>
              <p><?php echo $lang['admin_password'] ?></p>
            </td>
            <td>
              <p>
                <input type="password" size="45" name="admin_password" value="<?php echo stripslashes($admin_password); ?>">
              </p>
            </td>
          </tr>
          <tr>
            <td>
              <p><?php echo $lang['admin_password2'] ?></p>
            </td>
            <td>
              <p>
                <input type="password" size="45" name="admin_password2" value="<?php echo stripslashes($admin_password2); ?>">
              </p>
            </td>
          </tr>
          <tr>
            <td>
              <p><?php echo $lang['admin_email'] ?></p>
            </td>
            <td>
              <p>
                <input type="text" size="45" name="admin_email" value="<?php echo stripslashes($admin_email); ?>">
              </p>
            </td>
          </tr>
          <tr>
            <td colspan="2" align="center">
              <input type="hidden" name="action" value="startinstall">
              <input type="hidden" name="install_lang" value="<?php echo $install_lang; ?>">
              <input type="submit" value="   <?php echo $lang['start_install'] ?>   "  name="submit">
            </td>
          </tr>
        </table>
<?php
}
?>
      </td>
    </tr>
  </table>
</form>
<p align="center"> Powered by <b>123imagestock</b> <?php echo SCRIPT_VERSION ?><br/>
  Copyright &copy; 2007 <a href="http://www.123imagestock.com" target="_blank">123imagestock.com</a>
</p>
</body>
</html>